#include <bits/stdc++.h>
using namespace std;

const int64_t inf = (int64_t)1e18 + 42;

int n, m, real_n;
vector<tuple<int, int, int>> edges;
vector<vector<pair<int, int>>> adj;

void read() {
    cin >> n >> m;
    adj.assign(5 * n + 1, {});
    real_n = n;

    for(int i = 0; i < m; i++) {
        int u, l, r;
        cin >> u >> l >> r;
        u--, l--, r--;
        edges.emplace_back(u, l, r);
    }
}

vector<int> node;

int build_tree_struct(int l, int r, int idx) {
    if(l == r) {
        int v = n++;
        adj[v].push_back({l, 1});
        return node[idx] = v;
    }

    int mid = (l + r) / 2;
    int v = n++;
    adj[v].push_back({build_tree_struct(l, mid, 2 * idx + 1), 0});
    adj[v].push_back({build_tree_struct(mid + 1, r, 2 * idx + 2), mid - l + 1});
    return node[idx] = v;
}

void add_edges(int u, int ql, int qr, int l, int r, int idx) {
    if(ql > r || qr < l) {
        return;
    }
    if(ql <= l && r <= qr) {
        adj[u].push_back({node[idx], l - ql});
        return;
    }

    int mid = (l + r) / 2;
    add_edges(u, ql, qr, l, mid, 2 * idx + 1);
    add_edges(u, ql, qr, mid + 1, r, 2 * idx + 2);
}

vector<int64_t> dijkstra(int start) {
    vector<int64_t> dist(n, inf);
    dist[start] = 0;
    priority_queue<
        pair<int64_t, int>, vector<pair<int64_t, int>>,
        greater<pair<int64_t, int>>>
        pq;
    pq.push({0, start});

    while(!pq.empty()) {
        auto [d, u] = pq.top();
        pq.pop();

        if(dist[u] < d) {
            continue;
        }

        for(auto [v, w]: adj[u]) {
            if(dist[v] > dist[u] + w) {
                dist[v] = dist[u] + w;
                pq.push({dist[v], v});
            }
        }
    }

    return dist;
}

void solve() {
    node.resize(4 * real_n + 1);
    build_tree_struct(0, real_n - 1, 0);

    for(auto [u, l, r]: edges) {
        add_edges(u, l, r, 0, real_n - 1, 0);
    }

    vector<int64_t> ans = dijkstra(0);
    for(int i = 0; i < real_n; i++) {
        int64_t res = ans[i];
        if(res == inf) {
            cout << -1 << ' ';
        } else {
            cout << res << ' ';
        }
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();
    solve();
    return 0;
}
